import { createStore, compose, applyMiddleware } from 'redux';
import { createLogger } from 'redux-logger';
import { createEpicMiddleware } from 'redux-observable';
import { createElement, Component } from 'react';
import { RendererProvider } from 'react-fela';
import { Provider } from 'react-redux';
import { Router } from 'react-router';

var createIndoqaStore = function (_a) {
    var rootReducer = _a.rootReducer, rootEpic = _a.rootEpic, _b = _a.initialState, initialState = _b === void 0 ? {} : _b, enableLogging = _a.enableLogging;
    var epicMiddleware = createEpicMiddleware();
    var middleware = [epicMiddleware];
    if (enableLogging) {
        var logger = createLogger({
            collapsed: true,
        });
        middleware.push(logger);
    }
    var w = window;
    var devToolsExtension = typeof window !== 'undefined' && w.__REDUX_DEVTOOLS_EXTENSION__ ?
        w.__REDUX_DEVTOOLS_EXTENSION__() :
        function (f) { return f; };
    var indoqaStore = {
        reduxStore: createStore(rootReducer, initialState, compose(applyMiddleware.apply(void 0, middleware), devToolsExtension)),
        epicMiddleware: epicMiddleware,
    };
    epicMiddleware.run(rootEpic);
    return indoqaStore;
};

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};
function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var IndoqaApplication = (function (_super) {
    __extends(IndoqaApplication, _super);
    function IndoqaApplication() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    IndoqaApplication.prototype.render = function () {
        return (createElement(Provider, { store: this.props.store },
            createElement(RendererProvider, { renderer: this.props.renderer },
                createElement(Router, { history: this.props.history }, this.props.children))));
    };
    return IndoqaApplication;
}(Component));

export { createIndoqaStore, IndoqaApplication };
